/* ***********************************************************
 * This file was automatically generated on 2019-01-29.      *
 *                                                           *
 * C# Bindings Version 2.1.22                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Detects inclination of Bricklet (tilt switch open/closed)
	/// </summary>
	public class BrickletTilt : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 239;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Tilt Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_TILT_STATE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_ENABLE_TILT_STATE_CALLBACK = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_DISABLE_TILT_STATE_CALLBACK = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_IS_TILT_STATE_CALLBACK_ENABLED = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_TILT_STATE = 5;


		/// <summary>
		/// </summary>
		public const byte TILT_STATE_CLOSED = 0;

		/// <summary>
		/// </summary>
		public const byte TILT_STATE_OPEN = 1;

		/// <summary>
		/// </summary>
		public const byte TILT_STATE_CLOSED_VIBRATING = 2;


		/// <summary>
		///  This callback provides the current tilt state. It is called every time the
		///  state changes.
		///  
		///  See <see cref="Tinkerforge.BrickletTilt.GetTiltState"/> for a description of the states.
		/// </summary>
		public event TiltStateEventHandler TiltStateCallback;
		/// <summary>
		/// </summary>
		public delegate void TiltStateEventHandler(BrickletTilt sender, byte state);

		/// <summary>
		/// </summary>
		public event TiltStateEventHandler TiltState // for backward compatibility
		{
			add { TiltStateCallback += value; }
			remove { TiltStateCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletTilt(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_TILT_STATE] = new CallbackWrapper(OnTiltStateCallback);


			responseExpected[FUNCTION_GET_TILT_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_ENABLE_TILT_STATE_CALLBACK] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_DISABLE_TILT_STATE_CALLBACK] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_IS_TILT_STATE_CALLBACK_ENABLED] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
		}

		/// <summary>
		///  Returns the current tilt state. The state can either be
		///  
		///  * 0 = Closed: The ball in the tilt switch closes the circuit.
		///  * 1 = Open: The ball in the tilt switch does not close the circuit.
		///  * 2 = Closed Vibrating: The tilt switch is in motion (rapid change between open and close).
		///  
		///  .. image:: /Images/Bricklets/bricklet_tilt_mechanics.jpg
		///     :scale: 100 %
		///     :alt: Tilt states
		///     :align: center
		///     :target: ../../_images/Bricklets/bricklet_tilt_mechanics.jpg
		/// </summary>
		public byte GetTiltState()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TILT_STATE);

			byte[] response = SendRequest(request);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Enables the <see cref="Tinkerforge.BrickletTilt.TiltStateCallback"/> callback.
		/// </summary>
		public void EnableTiltStateCallback()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_ENABLE_TILT_STATE_CALLBACK);

			SendRequest(request);

		}

		/// <summary>
		///  Disables the <see cref="Tinkerforge.BrickletTilt.TiltStateCallback"/> callback.
		/// </summary>
		public void DisableTiltStateCallback()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_DISABLE_TILT_STATE_CALLBACK);

			SendRequest(request);

		}

		/// <summary>
		///  Returns *true* if the <see cref="Tinkerforge.BrickletTilt.TiltStateCallback"/> callback is enabled.
		/// </summary>
		public bool IsTiltStateCallbackEnabled()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_IS_TILT_STATE_CALLBACK_ENABLED);

			byte[] response = SendRequest(request);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnTiltStateCallback(byte[] response)
		{
			byte state = LEConverter.ByteFrom(8, response);
			var handler = TiltStateCallback;

			if (handler != null)
			{
				handler(this, state);
			}
		}
	}
}
