/* ***********************************************************
 * This file was automatically generated on 2019-01-29.      *
 *                                                           *
 * C# Bindings Version 2.1.22                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Controls AC and DC Solid State Relays
	/// </summary>
	public class BrickletSolidStateRelay : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 244;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Solid State Relay Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_STATE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_STATE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_MONOFLOP = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_MONOFLOP = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_MONOFLOP_DONE = 5;



		/// <summary>
		///  This callback is triggered whenever the monoflop timer reaches 0.
		///  The parameter is the current state of the relay
		///  (the state after the monoflop).
		/// </summary>
		public event MonoflopDoneEventHandler MonoflopDoneCallback;
		/// <summary>
		/// </summary>
		public delegate void MonoflopDoneEventHandler(BrickletSolidStateRelay sender, bool state);

		/// <summary>
		/// </summary>
		public event MonoflopDoneEventHandler MonoflopDone // for backward compatibility
		{
			add { MonoflopDoneCallback += value; }
			remove { MonoflopDoneCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletSolidStateRelay(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_MONOFLOP_DONE] = new CallbackWrapper(OnMonoflopDoneCallback);


			responseExpected[FUNCTION_SET_STATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MONOFLOP] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_MONOFLOP] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
		}

		/// <summary>
		///  Sets the state of the relays *true* means on and *false* means off.
		///  
		///  Running monoflop timers will be overwritten if this function is called.
		///  
		///  The default value is *false*.
		/// </summary>
		public void SetState(bool state)
		{
			byte[] request = CreateRequestPacket(9, FUNCTION_SET_STATE);
			LEConverter.To((bool)state, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the state of the relay, *true* means on and *false* means off.
		/// </summary>
		public bool GetState()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_STATE);

			byte[] response = SendRequest(request);

			return LEConverter.BoolFrom(8, response);
		}

		/// <summary>
		///  The first parameter  is the desired state of the relay (*true* means on
		///  and *false* means off). The second parameter indicates the time (in ms) that
		///  the relay should hold the state.
		///  
		///  If this function is called with the parameters (true, 1500):
		///  The relay will turn on and in 1.5s it will turn off again.
		///  
		///  A monoflop can be used as a failsafe mechanism. For example: Lets assume you
		///  have a RS485 bus and a Solid State Relay Bricklet connected to one of the slave
		///  stacks. You can now call this function every second, with a time parameter
		///  of two seconds. The relay will be on all the time. If now the RS485
		///  connection is lost, the relay will turn off in at most two seconds.
		/// </summary>
		public void SetMonoflop(bool state, long time)
		{
			byte[] request = CreateRequestPacket(13, FUNCTION_SET_MONOFLOP);
			LEConverter.To((bool)state, 8, request);
			LEConverter.To((int)time, 9, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the current state and the time as set by
		///  <see cref="Tinkerforge.BrickletSolidStateRelay.SetMonoflop"/> as well as the remaining time until the state flips.
		///  
		///  If the timer is not running currently, the remaining time will be returned
		///  as 0.
		/// </summary>
		public void GetMonoflop(out bool state, out long time, out long timeRemaining)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_MONOFLOP);

			byte[] response = SendRequest(request);

			state = LEConverter.BoolFrom(8, response);
			time = LEConverter.UIntFrom(9, response);
			timeRemaining = LEConverter.UIntFrom(13, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnMonoflopDoneCallback(byte[] response)
		{
			bool state = LEConverter.BoolFrom(8, response);
			var handler = MonoflopDoneCallback;

			if (handler != null)
			{
				handler(this, state);
			}
		}
	}
}
